const path = require('path');
const Webpack = require('webpack');
const nodeExternals = require('webpack-node-externals');

module.exports = {
  entry: './index.js',
  output: {
    filename: 'wizard_nodejs.js',
    library: '',
    libraryTarget: 'umd'
  },
  module: {
    rules: [{
      exclude: /node_modules/,
      use: {
        loader: 'babel-loader',
        options: {
          presets: ['@babel/preset-env'],
          plugins: ['@babel/plugin-transform-runtime', '@babel/plugin-proposal-class-properties']
        }
      }
    },
    {
      type: 'javascript/auto',
      test: /\.json$/,
      use: 'json-loader'
    }]
  },
  resolve: {
    extensions: ['.js', '.json'],
    alias: {
      '@': path.resolve('src'),
      '@@': path.resolve('.'),
      '#': path.resolve('test')
    }
  },
  target: 'node',
  externals: [
    nodeExternals()
  ],
  plugins: [
    // ingnore electron that used in got package
    new Webpack.IgnorePlugin(/^electron$/)
  ]
};
